drop procedure ITMUSER.POPULATE_OSAGENT
@
drop procedure ITMUSER.POPULATE_OSAGENTS
@

create procedure ITMUSER.POPULATE_OSAGENT(IN MSNCOL VARCHAR(50), IN FQHNCOL VARCHAR(50), IN DFQHNCOL VARCHAR(50), IN TABLENAME VARCHAR(50), IN OSTYPE VARCHAR(32))
LANGUAGE SQL
BEGIN
  --Declare variables to store results
  DECLARE v_ManagedSystemName VARCHAR (64);
  DECLARE v_FullyQualifiedHostname VARCHAR (64);
  DECLARE V_DYNAMIC VARCHAR(200);
  DECLARE V_SQL VARCHAR(500);
  DECLARE ROW_COUNT_STATEMENT VARCHAR(200);
  DECLARE ROW_COUNT_SQL VARCHAR(500);
  DECLARE row_count INTEGER DEFAULT 0;

  --Declare variables for checking end of loop
  DECLARE not_found CONDITION for SQLSTATE '02000';
  DECLARE NOROWS INTEGER DEFAULT 0;



  --Declare cursors 
  DECLARE resource_C CURSOR WITH RETURN FOR V_DYNAMIC;
  DECLARE row_count_C CURSOR WITH RETURN FOR ROW_COUNT_STATEMENT;
  
  DECLARE CONTINUE HANDLER FOR not_found SET NOROWS=1;
  SET V_SQL = 'SELECT DISTINCT ' || MSNCOL || ',max(coalesce(' || FQHNCOL || ',' || DFQHNCOL || ')) FROM ' || TABLENAME || ' WHERE coalesce(' || FQHNCOL || ',' || DFQHNCOL || ') NOT LIKE ''localhost%'' AND coalesce(' || FQHNCOL || ',' || DFQHNCOL || ') NOT LIKE ''loopback%'' AND coalesce(' || FQHNCOL || ',' || DFQHNCOL || ') NOT LIKE ''NO_DNS_ENTRY'' GROUP BY ' || MSNCOL; 
  PREPARE V_DYNAMIC FROM V_SQL;

  SET ROW_COUNT_SQL = 'SELECT count("System_Name") FROM ' || TABLENAME; 
  PREPARE ROW_COUNT_STATEMENT FROM ROW_COUNT_SQL;

  SET row_count = 0;
  OPEN row_count_C;
  FETCH row_count_C INTO row_count;
  CLOSE row_count_C;
  IF row_count > 0 THEN
    OPEN resource_C;
    FETCH resource_C INTO v_ManagedSystemName, v_FullyQualifiedHostname;
fetch_loop_win:
    REPEAT
      INSERT INTO ITMUSER.ManagedSystem (ManagedSystemName, FullyQualifiedHostname, DisplayName, AgentType)
             VALUES (v_ManagedSystemName, v_FullyQualifiedHostname, lower(REPLACE(REPLACE(REPLACE(REPLACE(v_ManagedSystemName, ':KUX', ''),'Primary:',''),':NT', ''),':LZ','')), OSTYPE);

      FETCH resource_C INTO v_ManagedSystemName, v_FullyQualifiedHostname;
    UNTIL NOROWS = 1
    END REPEAT fetch_loop_win;
    CLOSE resource_C;
    commit;
  END IF;
END
@

create procedure ITMUSER.POPULATE_OSAGENTS()
LANGUAGE SQL
BEGIN
  --Declare variables to store results
  DECLARE table_found VARCHAR (36);
 
  --Declare cursors for system catalog queries
  DECLARE linux_cat_C CURSOR WITH RETURN FOR SELECT NAME FROM SYSIBM.SYSTABLES WHERE NAME = 'Linux_IP_Address_DV';
  DECLARE unix_cat_C  CURSOR WITH RETURN FOR SELECT NAME FROM SYSIBM.SYSTABLES WHERE NAME = 'UNIX_IP_Address_DV';
  DECLARE win_cat_C   CURSOR WITH RETURN FOR SELECT NAME FROM SYSIBM.SYSTABLES WHERE NAME = 'NT_Computer_Information_DV';

  SET table_found = '';
  OPEN linux_cat_C;
  FETCH linux_cat_C INTO table_found;
  CLOSE linux_cat_C;
  IF table_found <> '' THEN
    DELETE FROM ITMUSER.ManagedSystem WHERE AgentType='linux';
    CALL ITMUSER.POPULATE_OSAGENT('"System_Name"', '"LAT_DNS_Name"', '"LAT_DNS_Name"', 'ITMUSER."Linux_IP_Address_DV"', 'linux');
  END IF;
  commit;
  
  SET table_found = '';
  OPEN unix_cat_C;
  FETCH unix_cat_C INTO table_found;
  CLOSE unix_cat_C;
  IF table_found <> '' THEN
    DELETE FROM ITMUSER.ManagedSystem WHERE AgentType='unix';
    CALL ITMUSER.POPULATE_OSAGENT('"System_Name"', '"LAT_DNS_Name"', '"LAT_DNS_Name"', 'ITMUSER."UNIX_IP_Address_DV"', 'unix');
  END IF;
  commit;

  SET table_found = '';
  OPEN win_cat_C;
  FETCH win_cat_C INTO table_found;
  CLOSE win_cat_C;
  IF table_found <> '' THEN
    DELETE FROM ITMUSER.ManagedSystem WHERE AgentType='windows';
    CALL ITMUSER.POPULATE_OSAGENT('"System_Name"', '"LAT_Computer_Domain_Name"', '"LAT_Computer_Hostname"', 'ITMUSER."NT_Computer_Information_DV"', 'windows');
  END IF;
  commit;

END
@ 