#!/bin/ksh

TCR_DEFAULT_DIR=/opt/IBM/tivoli/tip
TCR_COGNOS_JRE_FILE=products/tcr/Cognos/c8/bin/jre/1.5.0/bin/java
TCR_JRE_FILE=java/jre/bin/java
TCR_CMD_FILE=products/tcr/bin/trcmd.sh
TCR_ERROR_OUTPUT=/tmp/$$tcroutput.error


JEXEC=

if [ "$1" = "-console" ]; then
  CONSOLE=-console
  TCRHOME=$2
fi

if [ "$2" = "-console" ]; then
  CONSOLE=-console
  TCRHOME=$1
fi

if [ "$CONSOLE" = "" ]; then
  TCRHOME=$1
fi

if [ "$TCRHOME" = "" ]; then
  TCRHOME=$TCR_DEFAULT_DIR
fi


if [ -d $TCRHOME ] && [ -f $TCRHOME/$TCR_JRE_FILE ];
    then
      JEXEC=$TCRHOME/$TCR_JRE_FILE
    else
      JEXEC=$TCRHOME/$TCR_COGNOS_JRE_FILE
fi

if [ ! -f $JEXEC ]; then

    print "Usage: ./setup.sh <Tivoli Common Reporting installation location> /-console/"    
    print ""
    print "Unable to determine Java Runtime Environment in Tivoli Common Reporting directory. Enter valid Tivoli Common Reporting installation location."
    print "Use -console parameter to run installation in console mode."
    exit 1
fi

export JAVACMD=$JEXEC
$JEXEC -Dinstall.property.file=osagents_tcr_install.properties -jar report_installer.jar $CONSOLE 2>$TCR_ERROR_OUTPUT
